package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LittrsVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Litmod;
import com.ceb.gjjs.mda.manager.module.Litp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口信用证办理（转开、转递、转递&保兑）
*/
@Transaction(vo= LittrsVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Littrs extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Littrs.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Litmod litmod;

		@BDGetter
		private Litp litp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Littrs()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLitmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitmod().setLidgrpHolder(()->this.getLidgrp());
           this.getLitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitp().setLidgrpHolder(()->this.getLidgrp());
           this.getMtabut().setRecHolder(()->this.getLidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Littrs.this.getFieldPath("lidgrp.rec.issamt");}
 				public void setValue(BigDecimal arg){Littrs.this.getLidgrp().getRec().setIssamt(arg);}
 				public BigDecimal getValue(){return Littrs.this.getLidgrp().getRec().getIssamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Littrs.this.getFieldPath("lidgrp.bchcod");}
 				public void setValue(String arg){Littrs.this.getLidgrp().setBchcod(arg);}
 				public String getValue(){return Littrs.this.getLidgrp().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Littrs.this.getFieldPath("lidgrp.rec.isscur");}
 				public void setValue(String arg){Littrs.this.getLidgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Littrs.this.getLidgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Littrs.this.getFieldPath("lidgrp.rec.inr");}
 				public void setValue(String arg){Littrs.this.getLidgrp().getRec().setInr(arg);}
 				public String getValue(){return Littrs.this.getLidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Littrs.this.getFieldPath("lidgrp.rec.ownref");}
 				public void setValue(String arg){Littrs.this.getLidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Littrs.this.getLidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Littrs.this.getFieldPath("lidgrp.rec.ptyinr");}
 				public void setValue(String arg){Littrs.this.getLidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Littrs.this.getLidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Littrs.this.getFieldPath("lidgrp.rec.stlref");}
 				public void setValue(String arg){Littrs.this.getLidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Littrs.this.getLidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:littrs.@0004.script
        */
        @Rule(target="lidgrp.rec.avttyp",order=100)
        public boolean ruleLidgrpRecAvttypN100(){
            IContext ctx = MdaEnv.getContext();
            
			//1转开,2转递,3转递&保兑
			if("3".equals(this.getLidgrp().getRec().getAvttyp()))
			{
			  //Platform.setEmptyImpl(this.getLidgrp().getApl().getPts(),"ref");
			  //Platform.setEmptyImpl(this.getLidgrp().getRec(),"cfmcur");
			  //Platform.setEmptyImpl(this.getLidgrp().getRec(),"cfmamt");
			  this.getLidgrp().getRec().setCfmcur(this.getLidgrp().getRec().getIsscur());
			  this.getLidgrp().getRec().setCfmamt(this.getLidgrp().getRec().getIssamt());
			  //Platform.setEmptyImpl(this.getLidgrp().getBlk().getNegins());
			  
			  //Platform.setEmptyImpl(this.getLidgrp().getApl().getPts().getRef());
			  
			  //Platform.setEmptyImpl(this.getLidgrp().getRec().getCfmamt());
			  
			  
			  
			  
			  
			}
			else
			{

			  //Platform.setEmptyImpl(this.getLidgrp().getRec(),"cfmcur");
			  //Platform.setEmptyImpl(this.getLidgrp().getRec(),"cfmamt");
			  this.getLidgrp().getRec().setCfmcur(NULLSTR);
			  this.getLidgrp().getRec().setCfmamt(new BigDecimal(0));
			  //Platform.setEmptyImpl(this.getLidgrp().getRec().getCfmamt());
			  if("1".equals(this.getLidgrp().getRec().getAvttyp()))
			  {
			    //Platform.setEmptyImpl(this.getLidgrp().getApl().getPts(),"ref");
			    this.getLidgrp().getApl().getPts().setRef(NULLSTR);
			    //Platform.setEmptyImpl(this.getLidgrp().getBlk().getNegins());
			    //Platform.setEmptyImpl(this.getLidgrp().getApl().getPts().getRef());
			  }
			  else
			  {
			    //Platform.setEmptyImpl(this.getLidgrp().getApl().getPts(),"ref");
			    //Platform.setEmptyImpl(this.getLidgrp().getApl().getPts().getRef());
			    
			    //Platform.setEmptyImpl(this.getLidgrp().getBlk().getNegins());
			    
			  }

			  
			  
			  
			}

			return true;
        }

        /**
        *   source:littrs.@0005.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getLidgrp()))
			  return false;
			this.getLidgrp().getRec().setBchcod(this.getLidgrp().getBchcod());
			this.getLidgrp().getRec().setDbchcod(this.getLidgrp().getBchcod());
			ctx.getDaoSession().dbUpdate(this.getLidgrp().getRec());
			ctx.getDaoSession().dbUpdate(this.getLidgrp().getBlk());
			if(!ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  this.getLidgrp().getTrp().savTrp("lid",this.getLidgrp().getRec().getInr());
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay("litp/litp03",filename);

			return true;
        }

        /**
        *   source:littrs.@0006.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","littrs",stream,false );

			return true;
        }

        /**
        *   source:littrs.@0009.script
        */
        @Rule(target="lidgrp.rec.bchcod",order=100)
        public boolean ruleLidgrpRecBchcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }


        /**
        *   source:littrs.@0001.script
        */
        @Check(target="lidgrp.rec.cfmcur",order=100)
        public boolean checkLidgrpRecCfmcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getCfmcur()))
			  return true;
			if(!(this.getLidgrp().getRec().getCfmcur()).equals(this.getLidgrp().getRec().getIsscur()))
			{
			  ctx.setFieldError(this,"lidgrp.rec.cfmcur",MdaUtils.getI18NString("littrs","CT000000"));
			}

			return true;
        }

        /**
        *   source:littrs.@0002.script
        */
        @Check(target="lidgrp.rec.cfmamt",order=100)
        public boolean checkLidgrpRecCfmamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!"3".equals(this.getLidgrp().getRec().getAvttyp()))
			{
			  return true;
			}
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getCfmamt()))
			{
			  ctx.setFieldError(this,"lidgrp.rec.cfmamt",MdaUtils.getI18NString("littrs","CT000001"));
			}
			if((this.getLidgrp().getRec().getCfmamt()).compareTo(this.getLidgrp().getRec().getIssamt())>0)
			{
			  ctx.setFieldError(this,"lidgrp.rec.cfmamt",MdaUtils.getI18NString("littrs","CT000019"));
			}

			return true;
        }

        /**
        *   source:littrs.@0003.script
        */
        @Check(target="lidgrp.blk.docfwdins",order=0)
        public boolean checkLidgrpBlkDocfwdinsN0(){
            IContext ctx = MdaEnv.getContext();
            
			if(!"1".equals(this.getLidgrp().getRec().getAvttyp()))
			{
			  if("".equals(this.getLidgrp().getBlk().getDocfwdins()))
			  {
			    ctx.setFieldError(this,"lidgrp.blk.docfwdins",MdaUtils.getI18NString("littrs","CT000003"));
			  }
			}

			return true;
        }

        /**
        *   source:littrs.@0008.script
        */
        @Check(target="lidgrp.rec.avttyp",order=100)
        public boolean checkLidgrpRecAvttypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getLidgrp().getRec().getAvttyp()))
			  this.getLidgrp().setTrsflg("1");
			else if ("3".equals(this.getLidgrp().getRec().getAvttyp()))
			  this.getLidgrp().setTrsflg("2");

			return true;
        }


        /**
        *   source:littrs.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getLidgrp(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getLidgrp().setBchcod(bchcod.get(0).getValue());
			List<CodetableItem> bnkbchcod = this.getSysmod().getBchcod(this.getLidgrp().getRec().getPtyinr(),"3");
			MdaUtils.setValues(this.getLidgrp(),"bnkbchcod",bnkbchcod);
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"bchcod");
			if(this.getSysmod().sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  return true;
			this.getLidgrp().setBnkbchcod(this.getLidgrp().getRec().getBchcod());
			ctx.getDaoSession().dbRead(this.getLidgrp().getApl().getPts(),new Argument<String>("objinr",this.getLidgrp().getRec().getInr()),new Argument<String>("objtyp","lid"),new Argument<String>("rol","apl"));
			ctx.getDaoSession().dbRead(this.getLidgrp().getBen().getPts(),new Argument<String>("objinr",this.getLidgrp().getRec().getInr()),new Argument<String>("objtyp","lid"),new Argument<String>("rol","ben"));
			ctx.getDaoSession().dbRead(this.getLidgrp().getAdv().getPts(),new Argument<String>("objinr",this.getLidgrp().getRec().getInr()),new Argument<String>("objtyp","lid"),new Argument<String>("rol","adv"));
			ctx.getDaoSession().dbRead(this.getLidgrp().getDre().getPts(),new Argument<String>("objinr",this.getLidgrp().getRec().getInr()),new Argument<String>("objtyp","lid"),new Argument<String>("rol","dre"));
			this.getLidgrp().getRec().setAvttyp("1");
			this.getLidgrp().getRec().setCfmcur(this.getLidgrp().getRec().getIsscur());
			this.getLidgrp().getApl().getPts().setNam(this.getSysmod().getPty().getNam());
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"cfmcur");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"cfmamt");
			//Platform.setEmptyImpl(this.getLidgrp().getApl().getPts(),"ref");

			return true;
        }

        /**
        *   source:littrs.@0007.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.setEmptyImpl(this.getLidgrp().getDap().getPts(),"nam");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"conno");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"likman");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"concur");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"conamt");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"moble");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"ownref");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"email");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"bchcod");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"credat");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"isscur");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"issamt");
			//Platform.setEmptyImpl(this.getLidgrp().getBlk(),"word");
			//Platform.setEmptyImpl(this.getLidgrp().getApl().getPts(),"extkey");
			//Platform.setEmptyImpl(this.getLidgrp().getApl().getPts(),"adrblk");
			//Platform.setEmptyImpl(this.getLitp().getAplp(),"sel");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"nomflg");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"nomtop");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"nomton");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"expdat");
			//Platform.setEmptyImpl(this.getLidgrp().getBen().getPts(),"extkey");
			//Platform.setEmptyImpl(this.getLidgrp().getBen().getPts(),"adrblk");
			//Platform.setEmptyImpl(this.getLitp().getBenp(),"sel");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"expplc");
			//Platform.setEmptyImpl(this.getLidgrp().getAdv().getPts(),"extkey");
			//Platform.setEmptyImpl(this.getLidgrp().getAdv().getPts(),"adrblk");
			//Platform.setEmptyImpl(this.getLitp().getAdvp(),"sel");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"issinf");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"shppar");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"shptrs");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"trfflg");
			//Platform.setEmptyImpl(this.getLidgrp().getBlk(),"trfdet");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"upsflg");
			//Platform.setEmptyImpl(this.getLidgrp().getBlk(),"upsdet");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"avbwths");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"avbwth");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"avbby");
			//Platform.setEmptyImpl(this.getLidgrp().getBlk(),"defdet");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"cnfflg");
			//Platform.setEmptyImpl(this.getLidgrp().getBlk(),"cnfdet");
			//Platform.setEmptyImpl(this.getLidgrp().getBlk(),"mixdet");
			//Platform.setEmptyImpl(this.getLidgrp().getBlk(),"dftat");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"shpfro");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"porloa");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"pordis");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"shpto");
			//Platform.setEmptyImpl(this.getLidgrp().getDre().getPts(),"extkey");
			//Platform.setEmptyImpl(this.getLidgrp().getDre().getPts(),"adrblk");
			//Platform.setEmptyImpl(this.getLitp().getDrep(),"sel");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"trdtrm");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"trdtrmplc");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"trdtrmver");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"trdflg");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"shpdat");
			//Platform.setEmptyImpl(this.getLidgrp().getBlk(),"feetxt");
			//Platform.setEmptyImpl(this.getLidgrp().getBlk(),"adlcnd");
			//Platform.setEmptyImpl(this.getLitp().getAdlcnd(),"buttxmsel");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"sedday");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"sstdat");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"sstdattxt");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"preper");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"apprul");
			//Platform.setEmptyImpl(this.getLidgrp().getRec(),"apprultxt");
			//Platform.setEmptyImpl(this.getLidgrp().getBlk(),"lcrdoc");
			//Platform.setEmptyImpl(this.getLitp().getLcrdoc(),"buttxmsel");
			//Platform.setEmptyImpl(this.getLidgrp().getBlk(),"lcrgod");
			//Platform.setEmptyImpl(this.getLidgrp(),"agree");
			//Platform.setEmptyImpl(this.getLidgrp().getDap().getPts(),"nam");
			//Platform.setEmptyImpl(this.getLidgrp(),"rec");
			//Platform.dbRead($litp\\trstxt\\cls,new Argument<String>("flg","3"),new Argument<String>("typ","littrs"),new Argument<String>("status","0"));
			ctx.getDaoSession().dbRead(this.getLitp().getTrstxt().getCls(),new Argument<String>("inr",this.getLitp().getTrstxt().readDefaultClsInr("littrs")));
			this.getLidgrp().getBlk().setTrstxt(this.getLitp().getTrstxt().getCls().getClstxt());
			//Platform.disable($lidgrp\\blk\\trstxt);
			
			return true;
        }











}